ParseTreeRenderer (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.syntax

## Class ParseTreeRenderer

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JLabel
        - - hlt.language.syntax.ParseTreeRenderer

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.SwingConstants, javax.swing.tree.TreeCellRenderer

      public class ParseTreeRenderer
      extends javax.swing.JLabel
      implements javax.swing.tree.TreeCellRenderer

  This class customizes the original source of `javax.swing.tree.DefaultTreeCellRenderer` for rendering a parse tree display.

  Implementation note: (from original DefaultTreeCellRenderer authors) This class overrides `validate`, `revalidate`, `repaint`, and `firePropertyChange` solely to improve performance. If not overridden, these frequently called methods would execute code paths that are unnecessary for the default tree cell renderer. If you write your own renderer, take care to weigh the benefits and drawbacks of overriding these methods.

  Version:
    Last modified on Fri Apr 13 20:08:45 2012 by hak
  Author:
    Hassan Aït-Kaci
  See Also:
    `TreeDisplay`, Serialized Form
  Copyright:
    © by the author

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.BaselineResizeBehavior`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JComponent

      `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface javax.swing.SwingConstants

      `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ParseTreeRenderer()` Returns a new instance of ParseTreeRenderer.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `firePropertyChange(java.lang.String propertyName, boolean oldValue, boolean newValue)` Overridden for performance reasons.
    `void` | `firePropertyChange(java.lang.String propertyName, byte oldValue, byte newValue)` Overridden for performance reasons.
    `void` | `firePropertyChange(java.lang.String propertyName, char oldValue, char newValue)` Overridden for performance reasons.
    `void` | `firePropertyChange(java.lang.String propertyName, double oldValue, double newValue)` Overridden for performance reasons.
    `void` | `firePropertyChange(java.lang.String propertyName, float oldValue, float newValue)` Overridden for performance reasons.
    `void` | `firePropertyChange(java.lang.String propertyName, int oldValue, int newValue)` Overridden for performance reasons.
    `void` | `firePropertyChange(java.lang.String propertyName, long oldValue, long newValue)` Overridden for performance reasons.
    `void` | `firePropertyChange(java.lang.String propertyName, short oldValue, short newValue)` Overridden for performance reasons.
    `java.awt.Color` | `getBackgroundNonSelectionColor()` Returns the background color to be used for non selected nodes.
    `java.awt.Color` | `getBackgroundSelectionColor()` Returns the color to use for the background if node is selected.
    `java.awt.Color` | `getBorderSelectionColor()` Returns the color the border is drawn.
    `javax.swing.Icon` | `getClosedIcon()` Returns the icon used to represent non-leaf nodes that are not expanded.
    `javax.swing.Icon` | `getDefaultClosedIcon()` Returns the default icon, for the current laf, that is used to represent non-leaf nodes that are not expanded.
    `javax.swing.Icon` | `getDefaultLeafIcon()` Returns the default icon, for the current laf, that is used to represent leaf nodes.
    `javax.swing.Icon` | `getDefaultOpenIcon()` Returns the default icon, for the current laf, that is used to represent non-leaf nodes that are expanded.
    `javax.swing.Icon` | `getLeafIcon()` Returns the icon used to represent leaf nodes.
    `javax.swing.Icon` | `getOpenIcon()` Returns the icon used to represent non-leaf nodes that are expanded.
    `java.awt.Dimension` | `getPreferredSize()` Overrides `JComponent.getPreferredSize` to return slightly wider preferred size value.
    `java.awt.Color` | `getTextNonSelectionColor()` Returns the color the text is drawn with when the node isn't selected.
    `java.awt.Color` | `getTextSelectionColor()` Returns the color the text is drawn with when the node is selected.
    `java.awt.Component` | `getTreeCellRendererComponent(javax.swing.JTree tree, java.lang.Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus)` Configures the renderer based on the passed in components.
    `void` | `paint(java.awt.Graphics g)` Paints the value.
    `void` | `repaint(long tm, int x, int y, int width, int height)` Overridden for performance reasons.
    `void` | `repaint(java.awt.Rectangle r)` Overridden for performance reasons.
    `void` | `revalidate()` Overridden for performance reasons.
    `void` | `setBackground(java.awt.Color color)` Subclassed to map `ColorUIResource`s to null.
    `void` | `setBackgroundNonSelectionColor(java.awt.Color newColor)` Sets the background color to be used for non selected nodes.
    `void` | `setBackgroundSelectionColor(java.awt.Color newColor)` Sets the color to use for the background if node is selected.
    `void` | `setBorderSelectionColor(java.awt.Color newColor)` Sets the color to use for the border.
    `void` | `setClosedIcon(javax.swing.Icon newIcon)` Sets the icon used to represent non-leaf nodes that are not expanded.
    `void` | `setFont(java.awt.Font font)` Subclassed to map `FontUIResource`s to null.
    `void` | `setLeafIcon(javax.swing.Icon newIcon)` Sets the icon used to represent leaf nodes.
    `void` | `setOpenIcon(javax.swing.Icon newIcon)` Sets the icon used to represent non-leaf nodes that are expanded.
    `void` | `setTextNonSelectionColor(java.awt.Color newColor)` Sets the color the text is drawn with when the node isn't selected.
    `void` | `setTextSelectionColor(java.awt.Color newColor)` Sets the color the text is drawn with when the node is selected.
    `void` | `validate()` Overridden for performance reasons.

    - ### Methods inherited from class javax.swing.JLabel

      `getAccessibleContext, getDisabledIcon, getDisplayedMnemonic, getDisplayedMnemonicIndex, getHorizontalAlignment, getHorizontalTextPosition, getIcon, getIconTextGap, getLabelFor, getText, getUI, getUIClassID, getVerticalAlignment, getVerticalTextPosition, imageUpdate, setDisabledIcon, setDisplayedMnemonic, setDisplayedMnemonic, setDisplayedMnemonicIndex, setHorizontalAlignment, setHorizontalTextPosition, setIcon, setIconTextGap, setLabelFor, setText, setUI, setVerticalAlignment, setVerticalTextPosition, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ParseTreeRenderer

          public ParseTreeRenderer()

      Returns a new instance of ParseTreeRenderer. Alignment is set to left aligned. Icons and text color are determined from the UIManager.

  - ### Method Detail

    - #### getDefaultOpenIcon

          public javax.swing.Icon getDefaultOpenIcon()

      Returns the default icon, for the current laf, that is used to represent non-leaf nodes that are expanded.

    - #### getDefaultClosedIcon

          public javax.swing.Icon getDefaultClosedIcon()

      Returns the default icon, for the current laf, that is used to represent non-leaf nodes that are not expanded.

    - #### getDefaultLeafIcon

          public javax.swing.Icon getDefaultLeafIcon()

      Returns the default icon, for the current laf, that is used to represent leaf nodes.

    - #### setOpenIcon

          public void setOpenIcon(javax.swing.Icon newIcon)

      Sets the icon used to represent non-leaf nodes that are expanded.

    - #### getOpenIcon

          public javax.swing.Icon getOpenIcon()

      Returns the icon used to represent non-leaf nodes that are expanded.

    - #### setClosedIcon

          public void setClosedIcon(javax.swing.Icon newIcon)

      Sets the icon used to represent non-leaf nodes that are not expanded.

    - #### getClosedIcon

          public javax.swing.Icon getClosedIcon()

      Returns the icon used to represent non-leaf nodes that are not expanded.

    - #### setLeafIcon

          public void setLeafIcon(javax.swing.Icon newIcon)

      Sets the icon used to represent leaf nodes.

    - #### getLeafIcon

          public javax.swing.Icon getLeafIcon()

      Returns the icon used to represent leaf nodes.

    - #### setTextSelectionColor

          public void setTextSelectionColor(java.awt.Color newColor)

      Sets the color the text is drawn with when the node is selected.

    - #### getTextSelectionColor

          public java.awt.Color getTextSelectionColor()

      Returns the color the text is drawn with when the node is selected.

    - #### setTextNonSelectionColor

          public void setTextNonSelectionColor(java.awt.Color newColor)

      Sets the color the text is drawn with when the node isn't selected.

    - #### getTextNonSelectionColor

          public java.awt.Color getTextNonSelectionColor()

      Returns the color the text is drawn with when the node isn't selected.

    - #### setBackgroundSelectionColor

          public void setBackgroundSelectionColor(java.awt.Color newColor)

      Sets the color to use for the background if node is selected.

    - #### getBackgroundSelectionColor

          public java.awt.Color getBackgroundSelectionColor()

      Returns the color to use for the background if node is selected.

    - #### setBackgroundNonSelectionColor

          public void setBackgroundNonSelectionColor(java.awt.Color newColor)

      Sets the background color to be used for non selected nodes.

    - #### getBackgroundNonSelectionColor

          public java.awt.Color getBackgroundNonSelectionColor()

      Returns the background color to be used for non selected nodes.

    - #### setBorderSelectionColor

          public void setBorderSelectionColor(java.awt.Color newColor)

      Sets the color to use for the border.

    - #### getBorderSelectionColor

          public java.awt.Color getBorderSelectionColor()

      Returns the color the border is drawn.

    - #### setFont

          public void setFont(java.awt.Font font)

      Subclassed to map `FontUIResource`s to null. If `font` is null, or a `FontUIResource`, this has the effect of letting the font of the JTree show through. On the other hand, if `font` is non-null, and not a `FontUIResource`, the font becomes `font`.
      Overrides:
        `setFont` in class `javax.swing.JComponent`

    - #### setBackground

          public void setBackground(java.awt.Color color)

      Subclassed to map `ColorUIResource`s to null. If `color` is null, or a `ColorUIResource`, this has the effect of letting the background color of the JTree show through. On the other hand, if `color` is non-null, and not a `ColorUIResource`, the background becomes `color`.
      Overrides:
        `setBackground` in class `javax.swing.JComponent`

    - #### getTreeCellRendererComponent

          public java.awt.Component getTreeCellRendererComponent(javax.swing.JTree tree,
                                                        java.lang.Object value,
                                                        boolean sel,
                                                        boolean expanded,
                                                        boolean leaf,
                                                        int row,
                                                        boolean hasFocus)

      Configures the renderer based on the passed in components. The value is set from messaging the tree with `convertValueToText`, which ultimately invokes `toString` on `value`. The foreground color is set based on the selection and the icon is set based on leaf and expanded.
      Specified by:
        `getTreeCellRendererComponent` in interface `javax.swing.tree.TreeCellRenderer`

    - #### paint

          public void paint(java.awt.Graphics g)

      Paints the value. The background is filled based on selected.
      Overrides:
        `paint` in class `javax.swing.JComponent`

    - #### getPreferredSize

          public java.awt.Dimension getPreferredSize()

      Overrides `JComponent.getPreferredSize` to return slightly wider preferred size value.
      Overrides:
        `getPreferredSize` in class `javax.swing.JComponent`

    - #### validate

          public void validate()

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `validate` in class `java.awt.Container`

    - #### revalidate

          public void revalidate()

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `revalidate` in class `javax.swing.JComponent`

    - #### repaint

          public void repaint(long tm,
                     int x,
                     int y,
                     int width,
                     int height)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `repaint` in class `javax.swing.JComponent`

    - #### repaint

          public void repaint(java.awt.Rectangle r)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `repaint` in class `javax.swing.JComponent`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                byte oldValue,
                                byte newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `java.awt.Component`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                char oldValue,
                                char newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `javax.swing.JComponent`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                short oldValue,
                                short newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `java.awt.Component`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                int oldValue,
                                int newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `javax.swing.JComponent`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                long oldValue,
                                long newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `java.awt.Component`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                float oldValue,
                                float newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `java.awt.Component`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                double oldValue,
                                double newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `java.awt.Component`

    - #### firePropertyChange

          public void firePropertyChange(java.lang.String propertyName,
                                boolean oldValue,
                                boolean newValue)

      Overridden for performance reasons. See the Implementation Note for more information.
      Overrides:
        `firePropertyChange` in class `javax.swing.JComponent`